<template>
  <div></div>
</template>

<script>
import pdfMake from "pdfmake";
import htmlToPdfmake from "html-to-pdfmake";
import pdfFonts from "../../../assets/build/vfs_fonts";

import whApi from "@/api/warehouse/";

import numbro from "numbro";

export default {
  props: {
    dataExportPdf: Object,
  },
  data: () => ({
    jsonExport: [],

    newDataTable: [],

    user: "",
    numberToTh: "",
  }),
  async created() {
    await this.getAllMainPd();
    await this.getAllSubPd();
    await this.groupDateExport();
  },

  methods: {
    groupDateExport() {
      let newMainPd = {};
      let newSubPd = {};

      this.dataExportPdf.forEach((element, index) => {
        newMainPd = this.mainProduct.find(
          (data) => data.id === element.mainProductGroupId
        );

        newSubPd = this.subProduct.find(
          (data) => data.id === element.subProductGroupId
        );

        !newMainPd
          ? ""
          : !newSubPd
          ? ""
          : this.jsonExport.push({
              no: index + 1,
              productCode: element.product_code,
              productName: element.product_name,
              productBarcode: element.product_barcode,
              mainProduct: newMainPd.main_product_group_name,
              subProduct: newSubPd.sub_product_group_name,
              productPOG: element.product_pog,
              costPrice: numbro(element.product_cost_price).format({
                thousandSeparated: true,
                mantissa: 2,
              }),
              wholesalePrice: numbro(element.product_wholesale_price).format({
                thousandSeparated: true,
                mantissa: 2,
              }),
              retailPrice: numbro(element.product_retail_price).format({
                thousandSeparated: true,
                mantissa: 2,
              }),
              promotionPrice: element.product_promotion_price
                ? numbro(element.product_promotion_price).format({
                    thousandSeparated: true,
                    mantissa: 2,
                  })
                : "-",
              productQty: element.product_bring_qty,
              productInTransit: element.product_in_transit,
              productMix: element.product_min_stock,
              productMax: element.product_max_stock,
              is_cancel: element.is_cancel,
            });
      });

      this.setDataToTable();
    },

    async getAllMainPd() {
      // this.loading = true;
      let responseData = {};
      try {
        responseData = await whApi.mainProduct.getAll();
      } catch (error) {
        console.log(error);
      }
      if (responseData.response_status === "SUCCESS") {
        this.mainProduct = responseData.data;
        // this.loading = false;
      }
    },

    async getAllSubPd() {
      // this.loading = true;
      let responseData = {};
      try {
        responseData = await whApi.subProduct.getAll();
      } catch (error) {
        console.log(error);
      }
      if (responseData.response_status === "SUCCESS") {
        this.subProduct = responseData.data;
        // this.loading = false;
      }
    },

    exports() {
      const newWindow = window.open("", "_blank");

      pdfMake.vfs = pdfFonts.pdfMake.vfs;
      pdfMake.fonts = {
        Roboto: {
          normal: "Kanit-Regular.ttf",
          bold: "Kanit-Medium.ttf",
          italics: "Kanit-Medium.ttf",
          bolditalics: "Kanit-Medium.ttf",
        },
      };

      console.log(this.jsonExport);

      const html = [
        {
          text: "ราคาขาย / ป้ายราคา",
          fontSize: 16,
          bold: true,
          margin: [0, 0, 0, 10],
        },

        // TABLE
        {
          table: {
            // widths: [
            //   "*",
            //   "*",
            //   "*",
            //   "*",
            //   "*",
            //   "*",
            //   "*",
            //   "*",
            //   "*",
            //   "*",
            //   "*",
            //   "*",
            //   "*",
            //   "*",
            //   "*",
            // ],
            body: this.newDataTable,
          },
        },
      ];

      const pdfData = {
        content: html,
        pageOrientation: "landscape",
      };
      pdfMake.createPdf(pdfData).open({}, newWindow);
      this.$emit("allGeneratedFile");
    },

    setDataToTable() {
      this.jsonExport.forEach((element, index) => {
        if (index === 0) {
          this.newDataTable.push(
            [
              {
                fontSize: 9,
                text: "#",
                alignment: "center",
              },
              {
                fontSize: 9,
                text: "รหัสสินค้า",
                alignment: "center",
              },
              {
                fontSize: 9,
                text: "ชื่อสินค้า",
                alignment: "center",
              },
              {
                fontSize: 9,
                text: "Barcode",
                alignment: "center",
              },
              {
                fontSize: 9,
                text: "กลุ่มสินค้าหลัก",
                alignment: "center",
              },
              {
                fontSize: 9,
                text: "กลุ่มสินค้ารอง",
                alignment: "center",
              },
              {
                fontSize: 9,
                text: "POG",
                alignment: "center",
              },
              {
                fontSize: 9,
                text: "ราคาทุน",
                alignment: "center",
              },
              {
                fontSize: 9,
                text: "ราคาส่ง",
                alignment: "center",
              },
              {
                fontSize: 9,
                text: "ราคาปลีก",
                alignment: "center",
              },
              {
                fontSize: 9,
                text: "ราคาโปร",
                alignment: "center",
              },
              {
                fontSize: 9,
                text: "Qty",
                alignment: "center",
              },
              {
                fontSize: 9,
                text: "In Transit",
                alignment: "center",
              },
              {
                fontSize: 9,
                text: "Mix",
                alignment: "center",
              },
              {
                fontSize: 9,
                text: "Max",
                alignment: "center",
              },
              {
                fontSize: 9,
                text: "Status",
                alignment: "center",
              },
            ],
            [
              {
                text: element.no,
                fontSize: 9,
                fillColor: "#eaeced",
              },
              {
                text: element.productCode,
                fontSize: 9,
                fillColor: "#eaeced",
              },
              {
                text: element.productName,
                fontSize: 9,
                fillColor: "#eaeced",
              },
              {
                text: element.productBarcode,
                fontSize: 9,
                fillColor: "#eaeced",
              },
              {
                text: element.mainProduct,
                fontSize: 9,
                fillColor: "#eaeced",
              },
              {
                text: element.subProduct,
                fontSize: 9,
                fillColor: "#eaeced",
              },
              {
                text: element.productPOG,
                fontSize: 9,
                fillColor: "#eaeced",
              },
              {
                text: element.costPrice,
                fontSize: 9,
                fillColor: "#eaeced",
                alignment: "right",
              },
              {
                text: element.wholesalePrice,
                fontSize: 9,
                fillColor: "#eaeced",
                alignment: "right",
              },
              {
                text: element.retailPrice,
                fontSize: 9,
                fillColor: "#eaeced",
                alignment: "right",
              },
              {
                text: element.promotionPrice,
                fontSize: 9,
                fillColor: "#eaeced",
                alignment: "right",
              },
              {
                text: element.productQty,
                fontSize: 9,
                fillColor: "#eaeced",
                alignment: "right",
              },
              {
                text: element.productInTransit,
                fontSize: 9,
                fillColor: "#eaeced",
                alignment: "right",
              },
              {
                text: element.productMix,
                fontSize: 9,
                fillColor: "#eaeced",
                alignment: "right",
              },
              {
                text: element.productMax,
                fontSize: 9,
                fillColor: "#eaeced",
                alignment: "right",
              },
              {
                text: element.is_cancel === "0" ? "ใช้งาน" : "ยกเลิกใช้งาน",
                fontSize: 9,
                fillColor: "#eaeced",
                color: element.is_cancel === "0" ? "green" : "red",
                alignment: "center",
              },
            ]
          );
        } else {
          this.newDataTable.push([
            {
              text: element.no,
              fontSize: 9,
              fillColor: index % 2 === 0 ? "#eaeced" : "",
            },
            {
              text: element.productCode,
              fontSize: 9,
              fillColor: index % 2 === 0 ? "#eaeced" : "",
            },
            {
              text: element.productName,
              fontSize: 9,
              fillColor: index % 2 === 0 ? "#eaeced" : "",
            },
            {
              text: element.productBarcode,
              fontSize: 9,
              fillColor: index % 2 === 0 ? "#eaeced" : "",
            },
            {
              text: element.mainProduct,
              fontSize: 9,
              fillColor: index % 2 === 0 ? "#eaeced" : "",
            },
            {
              text: element.subProduct,
              fontSize: 9,
              fillColor: index % 2 === 0 ? "#eaeced" : "",
            },
            {
              text: element.productPOG,
              fontSize: 9,
              fillColor: index % 2 === 0 ? "#eaeced" : "",
            },
            {
              text: element.costPrice,
              fontSize: 9,
              fillColor: index % 2 === 0 ? "#eaeced" : "",
              alignment: "right",
            },
            {
              text: element.wholesalePrice,
              fontSize: 9,
              fillColor: index % 2 === 0 ? "#eaeced" : "",
              alignment: "right",
            },
            {
              text: element.retailPrice,
              fontSize: 9,
              fillColor: index % 2 === 0 ? "#eaeced" : "",
              alignment: "right",
            },
            {
              text: element.promotionPrice,
              fontSize: 9,
              fillColor: index % 2 === 0 ? "#eaeced" : "",
              alignment: "right",
            },
            {
              text: element.productQty,
              fontSize: 9,
              fillColor: index % 2 === 0 ? "#eaeced" : "",
              alignment: "right",
            },
            {
              text: element.productInTransit,
              fontSize: 9,
              fillColor: index % 2 === 0 ? "#eaeced" : "",
              alignment: "right",
            },
            {
              text: element.productMix,
              fontSize: 9,
              fillColor: index % 2 === 0 ? "#eaeced" : "",
              alignment: "right",
            },
            {
              text: element.productMax,
              fontSize: 9,
              fillColor: index % 2 === 0 ? "#eaeced" : "",
              alignment: "right",
            },
            {
              text: element.is_cancel === "0" ? "ใช้งาน" : "ยกเลิกใช้งาน",
              fontSize: 9,
              fillColor: index % 2 === 0 ? "#eaeced" : "",
              color: element.is_cancel === "0" ? "green" : "red",
              alignment: "center",
            },
          ]);
        }
      });

      this.exports();
    },
  },
};
</script>
